#!/bin/bash

# Creates all the links that will be used as a fake RAID/JBOD for the Samba
# shares. This allows me to aggregate all the drives into a single structure
# that is easy to understand and to know where the f@#! are my stuff.

loop_ln() {
    for d in *; do
        if [ -d "$d" ]; then
            ln -s "${1}/${d}" "${2}/${d}"
        fi
    done
}

MOUNT_FOLDER="{{ topology.roles[current_group_role].data.paths.drives }}/"
DATA_FOLDER="{{ topology.roles[current_group_role].data.paths.pool }}/"

service smbd stop

# Delete and recreate the root folder.
rm -rf "${DATA_FOLDER}"
mkdir "${DATA_FOLDER}"

###############################################################################
# CONTENT_1
###############################################################################

mkdir "${DATA_FOLDER}Media"

# Use this format to link individual sub-folders instead of linking the parent.
#mkdir "${DATA_FOLDER}Media/Émissions TV"
#ORIGINAL_FOLDER_PATH="${MOUNT_FOLDER}CONTENT_1/data/Media/Émissions TV"
#DESTINATION_FOLDER_PATH="${DATA_FOLDER}Media/Émissions TV"
#(cd "${ORIGINAL_FOLDER_PATH}"; loop_ln "$ORIGINAL_FOLDER_PATH" "$DESTINATION_FOLDER_PATH")

ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/Movies" "${DATA_FOLDER}Media/Movies"
ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/Movies (Documentary)" "${DATA_FOLDER}Media/Movies (Documentary)"
ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/Movies (for kids)" "${DATA_FOLDER}Media/Movies (for kids)"
ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/TV Shows" "${DATA_FOLDER}Media/TV Shows"
ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/TV Shows (Documentary)" "${DATA_FOLDER}Media/TV Shows (Documentary)"
ln -s "${MOUNT_FOLDER}CONTENT_1/data/Media/TV Shows (for kids)" "${DATA_FOLDER}Media/TV Shows (for kids)"

###############################################################################
# CONTENT_2
###############################################################################

ln -s "${MOUNT_FOLDER}CONTENT_2/data/Applications" "${DATA_FOLDER}Applications"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Backups" "${DATA_FOLDER}Backups"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Documents" "${DATA_FOLDER}Documents"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Downloads" "${DATA_FOLDER}Downloads"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Books" "${DATA_FOLDER}Media/Books"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Émissions TV" "${DATA_FOLDER}Media/Émissions TV"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Émissions TV (pour enfants)" "${DATA_FOLDER}Media/Émissions TV (pour enfants)"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Films" "${DATA_FOLDER}Media/Films"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Films (pour enfants)" "${DATA_FOLDER}Media/Films (pour enfants)"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Fitness & Cardio" "${DATA_FOLDER}Media/Fitness & Cardio"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Music" "${DATA_FOLDER}Media/Music"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Music Videos" "${DATA_FOLDER}Media/Music Videos"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Pictures" "${DATA_FOLDER}Media/Pictures"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Training" "${DATA_FOLDER}Media/Training"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/Media/Youtube" "${DATA_FOLDER}Media/Youtube"
ln -s "${MOUNT_FOLDER}CONTENT_2/data/rip" "${DATA_FOLDER}rip"

chown -R {{ topology.roles[current_group_role].data.user.name }}:{{ topology.roles[current_group_role].data.user.group }} "${DATA_FOLDER}"

service smbd start
